RedmineUpgrade » History » Version 30

« Previous - Version 30/69 (diff) - Next » - Current version
Zach Gardner, 2010-02-02 21:26


Upgrading

Step 1 - Check requirements

The first step to upgrading Redmine is to check that you meet the requirements for the version you're about to install.

Step 2 - Backup

It is recommended that you backup your database and file uploads. Most upgrades are safe but it never hurts to have a backup just in case.

Backing up the files

All file uploads are stored to the files/ directory. You can copy the contents of this directory to a another location to easily back it up.

MySQL database

The mysqldump command can be used to backup the contents of your MySQL database to a text file.

SQLite database

SQLite databases are all contained in a single file, so you can back them up by copying the file to another location.

PostgreSQL

The pg_dump command can be used to backup the contents of a PostgreSQL database to a text file.

Step 3 - Perform the upgrade

Now it's time to perform the actual upgrade. This process if different depending on how you downloaded Redmine. You only need to perform one of the following options.

Option 1 - Downloaded release (tar.gz or zip file)

1. Uncompress the new program archive in a new directory.

2. Copy your database settings-file config/database.yml into the new config directory.

3. Copy your email settings-file config/email.yml into the new config directory.

4. Copy the RAILS_ROOT/files directory content into your new installation.

5. Copy the folders of your installed plugins into new installation directory

6. Run the following command from your Redmine root directory:

rake config/initializers/session_store.rb

This will generate a file (config/initializers/session_store.rb) with a random secret used to secure session data.

7. Check for any themes that you may have installed in the "public/themes" directory. You can copy them over but checking for updated version is ideal.

VERY IMPORTANT: do NOT overwrite config/settings.yml with the old one.

Option 2 - Upgrading from a SVN checkout

1. Go to the Redmine root directory and run the following command:

svn update

2. If you are upgrading from an older version to 0.8.7+ or from the trunk version of Redmine to r2493 or above, you must generate a secret for cookie store. See the note at the bottom about generating a session_store.

Step 4 - Update the database

This step is the one that could change the contents of your database. Go to your new redmine directory, then migrate your database:

rake db:migrate RAILS_ENV=production 

If you have installed any plugins, you should also run their database migrations. If you are upgrading to Rails 2.2.2 as part of this migration, you need to upgrade the plugin migrations first:

rake db:migrate:upgrade_plugin_migrations RAILS_ENV=production 
rake db:migrate_plugins RAILS_ENV=production 

Step 5 - Clean up

1. You should clear the cache and the existing sessions:

rake tmp:cache:clear
rake tmp:sessions:clear

2. Restart the application server (e.g. mongrel, thin, passenger)

3. Finally go to "Admin -> Roles & permissions" to check/set permissions for the new features, if any.

Common issues

Errors with repository management

There were several new features added to the reposman.rb file, make sure you have a group specified if you're having issues ( --group=groupnamehere). Also, make sure you follow the instructions here again if you only copied your Redmine.pm, and update your Apache configuration as the recommended configuration has changed.

Generating a session_store.rb

An unique session_store.rb file needs to be generated for Redmine for the new cookie based sessions to work. This is required on the trunk version of Redmine at r2493 or above. Just run the following command and Redmine will create one for you:

rake config/initializers/session_store.rb

Errors about a missing session_store.rb

If you see any errors about a missing session_store.rb file, run the command above to create a new one.

Error about the Rails version

Also remember that the trunk version of Redmine after r2886 uses Rails 2.3.5, so you will need to upgrade your Ruby on Rails gem:

gem install rails -v=2.3.5